/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include <ggi/graphlib.h>

static int drawline_lower(int unused,void *xyxy)
{ 
	struct { int x1,y1,x2,y2; } *par;
	int dx,dy,sx,sy,st,bla;
	par=xyxy;
	
	sx=1;dx=par->x2-par->x1;if (dx<0) {sx=-1;dx=-dx;}
	sy=1;dy=par->y2-par->y1;if (dy<0) {sy=-1;dy=-dy;}
	st=(dx-dy);bla=(dx>dy);

	ggi_drawpixel(par->x1,par->y1);
	while(par->x1!=par->x2&&par->y1!=par->y2)
	{
	  ggi_drawpixel(par->x1,par->y1);
	  if (st<0) { par->y1+=sy;st+=dx;
	  	      if ( bla) ggi_drawpixel(par->x1,par->y1);
		    }
	  else      { par->x1+=sx;st-=dy;
	  	      if (!bla) ggi_drawpixel(par->x1,par->y1);
	  	    }
	}
	return(0);
}

/***************************/
/* draw a line - bresenham */
/***************************/
int ggi_drawline(int x1,int y1,int x2,int y2)
{ 
	switchavail(GRAPHICS_DRAWLINE,&x1);

	switcha(GRAPHICS_DRAWLINE)
	{ case AVM_MMAP :	/* we need no special mmap.Pixeling will do.*/
	  case AVM_LOWER:
	  	setdoemu(GRAPHICS_DRAWLINE,AVE_ALWAYS,drawline_lower,&x1);
   		break;
	  default       :
	  	ggi_panic("hline - no method.");
	  	break;
  }
  return(0);
}


